/**
 **	File ......... Dialog.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#include "guicolors.h"
#ifdef _WIN32
#pragma warning(push)

#include <yvals.h> // warning numbers get enabled in yvals.h 

#pragma warning(disable: 4251)  
#pragma warning(disable: 4786)  // identifier was truncated to 'number' characters in the debug information

// BUG: C4786 Warning Is Not Disabled with #pragma Warning
// STATUS: Microsoft has confirmed this to be a bug in the Microsoft product. This warning can be ignored.
// This occured only in the <map> container.

#include <sge.h>

#pragma warning(pop)
#else
#include <sge.h>
#endif

#include "Surface.h"
#include "Hotspot.h"
#include "Dialog.h"


namespace gui
{


Dialog::Dialog(Surface *s,coord_t x,coord_t y,coord_t w,coord_t h,SurfaceHelper *pclHelper)
:Surface(s,x,y,w,h,pclHelper)
,m_movespot(s,w - SBSIZE,h - SBSIZE,SBSIZE,SBSIZE)
{
	SetBgColor(DIALOG_DEFAULT_BG_R,DIALOG_DEFAULT_BG_G,DIALOG_DEFAULT_BG_B);
	SetFrameWidth(DIALOG_DEFAULT_FW);
	SetFrameColor(DIALOG_DEFAULT_FC_R,DIALOG_DEFAULT_FC_G,DIALOG_DEFAULT_FC_B);

	m_movespot.SetResizeArea(true);
	m_movespot.SetFrameWidth(0);
	m_movespot.SetAnchorRight( true );
	m_movespot.SetAnchorDown( true );
	AddChild(&m_movespot);
}


Dialog::~Dialog()
{
}


void Dialog::Draw()
{
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color = GetBgColor();

	SDL_FillRect(m_screen, area, color);
}


void Dialog::AddChild(Surface *s)
{
	Surface::AddChild(s);

//	m_movespot.BringToTop();
	BringToTop(&m_movespot);
}


void Dialog::OnRightClick(coord_t x,coord_t y)
{
	OnClose();
}


} // namespace
