/**
 **	File ......... GuiEvent.h
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _GUIEVENT_H
#define _GUIEVENT_H


namespace gui
{
class Surface;

class GuiEvent;
//typedef void (GuiEvent::*UICOMMAND)(Surface *,long);
typedef void (*UICOMMAND)(Surface *,long);
typedef std::map<long,UICOMMAND> uicmdmap_t;

class GuiEvent
{
public:
	GuiEvent();
	virtual ~GuiEvent();

	void SetRootSurface(Surface *);
	void SetSDLControl(SDLControl *);
	void SetDefaultFocus(Surface *);
	void SetQuit(bool);
	void RegUICmdMethod(long,UICOMMAND);

	bool RightMouseButtonDown();

	virtual void KeyboardEvent(SDL_KeyboardEvent &);
	virtual void MouseMotionEvent(SDL_MouseMotionEvent &);
	virtual void MouseButtonEvent(SDL_MouseButtonEvent &);
	virtual void UserEvent(SDL_UserEvent &);
	virtual void EventLoop();

private:
	static Surface *m_mouse;
	static Surface *m_selected;
	static Surface *m_focus;
	static Surface *m_moving;
	static Surface *m_sizing;
	static Surface *m_trackbutton;
	static Surface *m_default_focus;
	void SetFocus(Surface *);
	void SetSelected(Surface *);
	Surface *m_pclRootSurface;
	SDLControl *m_pclControl;
	bool m_bLeftButtonPressed;
	coord_t m_leftx;
	coord_t m_lefty;
	bool m_bMiddleButtonPressed;
	coord_t m_middlex;
	coord_t m_middley;
	bool m_bRightButtonPressed;
	coord_t m_rightx;
	coord_t m_righty;
	bool m_bQuit;
	rectvector_t m_vecInvalidRects;
	rectvector_t m_vecFillRects;
	int m_sizing_w;
	int m_sizing_h;
	uicmdmap_t m_uicmdmap;
};
} // namespace


#endif // _GUIEVENT_H
