/**
 **	File ......... Output.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#ifdef _WIN32
#pragma warning(push)

#include <yvals.h> // warning numbers get enabled in yvals.h 

#pragma warning(disable: 4251)  
#pragma warning(disable: 4786)  // identifier was truncated to 'number' characters in the debug information

// BUG: C4786 Warning Is Not Disabled with #pragma Warning
// STATUS: Microsoft has confirmed this to be a bug in the Microsoft product. This warning can be ignored.
// This occured only in the <map> container.

#include <sge.h>

#pragma warning(pop)
#else
#include <sge.h>
#endif
//#include <iotm/Mutex.h> // iotm

#include "TTFont.h"
#include "SDLControl.h"
#include "Surface.h"
#include "Output.h"


namespace gui
{


Output::Output(Surface *s,coord_t x,coord_t y,coord_t w,coord_t h,SurfaceHelper *pclHelper)
:Surface(s,x,y,w,h,pclHelper)
{
}


Output::~Output()
{
}


void Output::AddLine(const string &str)
{
	TTFont *font = GetTTFont();
	stringvector_t::iterator it;

//	m_mutex.Lock();
	m_lines = GetH() / font -> GetH();
	while (m_strings.size() < (unsigned)m_lines)
	{
		m_strings.insert(m_strings.end(), "");
	}

	m_strings.insert(m_strings.end(), str);
	while (m_strings.size() > (unsigned)m_lines)
	{
		m_strings.erase(m_strings.begin());
	}
//	m_mutex.Unlock();
	SetDirty(true);
//	DrawAll();
//	RedrawEv();
//	m_mutex.Lock();
	SDL_Rect r = GetAbsoluteRect();
	r.w = 0;
	for (it = m_strings.begin(); it != m_strings.end(); it++)
	{
		SDL_Rect rect = sge_TTF_TextSize(font -> GetFont(), (char *)(*it).c_str() );
		if (rect.w > r.w)
		{
			r.w = rect.w;
		}
	}
//	m_mutex.Unlock();
DEB(printf("InvalidateRectEv(%d,%d,%d,%d)\n",r.x,r.y,r.w,r.h);)
	InvalidateRectEv(r);
}


void Output::Draw()
{
	stringvector_t::iterator it;
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color;
	TTFont *font = GetTTFont();
	SDL_Color fg;
	SDL_Color bg;
	coord_t x = 0;
	coord_t y = font -> GetH();

	color = GetFgColor();
	memmove(&fg,&color,4);
	color = GetBgColor();
	memmove(&bg,&color,4);

	SDL_FillRect(m_screen, area, color );
//	m_mutex.Lock();
	for (it = m_strings.begin(); it != m_strings.end(); it++)
	{
		sge_tt_textoutf(m_screen, font -> GetFont(),
			x,y,
			fg.r,fg.g,fg.b,
			bg.r,bg.g,bg.b,
			SDL_ALPHA_OPAQUE,
			"%s",(*it).c_str());
		y += font -> GetH();
	}
//	m_mutex.Unlock();
}


} // namespace
