/**
 **	File ......... SeparatorMenuItem.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#include "guicolors.h"
#ifdef _WIN32
#pragma warning(push)

#include <yvals.h> // warning numbers get enabled in yvals.h 

#pragma warning(disable: 4251)  
#pragma warning(disable: 4786)  // identifier was truncated to 'number' characters in the debug information

// BUG: C4786 Warning Is Not Disabled with #pragma Warning
// STATUS: Microsoft has confirmed this to be a bug in the Microsoft product. This warning can be ignored.
// This occured only in the <map> container.

#include <sge.h>

#pragma warning(pop)
#else
#include <sge.h>
#endif

#include "TTFont.h"
#include "Surface.h"
#include "Hotspot.h"
#include "MenuItem.h"
#include "SeparatorMenuItem.h"


namespace gui
{


SeparatorMenuItem::SeparatorMenuItem(Surface *s,SurfaceHelper *pclHelper)
:MenuItem(s,"",NULL,pclHelper)
{
	SetH(5, false);
	SetClickable(false);
}


SeparatorMenuItem::~SeparatorMenuItem()
{
}


void SeparatorMenuItem::Draw()
{
	SDL_Rect r;
	SDL_Rect *area = GetClientRectPtr();

	SDL_FillRect(m_screen, area, GetBgColor());
	
	r.x = 2;
	r.y = 2;
	r.w = GetW() - 4;
	r.h = 1;
	SDL_FillRect(m_screen, &r, GetFgColor());
}


} // namespace
