/**
 **	File ......... Static.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#include "guicolors.h"
#ifdef _WIN32
#pragma warning(push)

#include <yvals.h> // warning numbers get enabled in yvals.h 

#pragma warning(disable: 4251)  
#pragma warning(disable: 4786)  // identifier was truncated to 'number' characters in the debug information

// BUG: C4786 Warning Is Not Disabled with #pragma Warning
// STATUS: Microsoft has confirmed this to be a bug in the Microsoft product. This warning can be ignored.
// This occured only in the <map> container.

#include <sge.h>

#pragma warning(pop)
#else
#include <sge.h>
#endif
//#include <iotm/Mutex.h> // iotm

#include "TTFont.h"
//#include "TimerThread.h"
#include "SDLControl.h"
#include "Surface.h"
#include "Static.h"


namespace gui
{


Static::Static(Surface *s,coord_t x,coord_t y,coord_t w,coord_t h,SurfaceHelper *pclHelper)
:Surface(s,x,y,w,h,pclHelper)
{
//	SetBgColor(STATIC_DEFAULT_BG);
	SetFgColor(STATIC_DEFAULT_FG_R,STATIC_DEFAULT_FG_G,STATIC_DEFAULT_FG_B);
	SetFrameWidth(STATIC_DEFAULT_FW);
}


Static::~Static()
{
}


void Static::Draw()
{
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color;
	TTFont *font = GetTTFont();
	SDL_Color fg;
	SDL_Color bg;
//	SDLControl *pcl = GetSDLControl();
//	Uint32 tr = SDL_MapRGBA(pcl -> GetScreen() -> format, 255, 255, 255, 0);

	color = GetFgColor();
	memmove(&fg,&color,4);
	color = GetBgColor();
	memmove(&bg,&color,4);

	// color 0 - transparent
	SDL_FillRect(m_screen, area, color);

	if (font && font -> GetFont())
	{
		coord_t h = font -> GetH();
		coord_t y = GetH() / 2 + h / 2;

		sge_tt_textoutf(m_screen, font -> GetFont(),
			10,y,
			fg.r,fg.g,fg.b,
			bg.r,bg.g,bg.b,
			SDL_ALPHA_OPAQUE,
			"%s",GetText());
	}
}


} // namespace
