/**
 **	File ......... TTFont.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#ifdef _WIN32
#pragma warning(push)

#include <yvals.h> // warning numbers get enabled in yvals.h 

#pragma warning(disable: 4251)  
#pragma warning(disable: 4786)  // identifier was truncated to 'number' characters in the debug information

// BUG: C4786 Warning Is Not Disabled with #pragma Warning
// STATUS: Microsoft has confirmed this to be a bug in the Microsoft product. This warning can be ignored.
// This occured only in the <map> container.

#include <sge.h>

#pragma warning(pop)
#else
#include <sge.h>
#endif

#include "TTFont.h"


namespace gui
{

bool TTFont::m_init = false;

TTFont::TTFont(const string &filename,int size) : m_font(NULL)
,m_h(size)
{
	/* Init TTF */
	if (!m_init)
	{
		m_init = true;
		if (sge_TTF_Init()!=0)
		{
			fprintf(stderr,"TT error: %s\n", SDL_GetError());
//			exit(1);
		}
	}

	m_font = sge_TTF_OpenFont( (char *)filename.c_str(), size);
	if (m_font == NULL)
	{
		fprintf(stderr,"TT error: %s\n", SDL_GetError());
//		exit(1);
	}

	//sge_TTF_SetFontStyle(m_font, SGE_TTF_ITALIC);
}


TTFont::~TTFont()
{
	/* Clean up */
	if (m_font)
	{
		sge_TTF_CloseFont(m_font);
	}
}


sge_TTFont *TTFont::GetFont()
{
	return m_font;
}


int TTFont::GetH()
{
	return m_h;
}


void TTFont::SetH(int h)
{
	m_h = h;
	sge_TTF_SetFontSize(m_font, h);
}


void TTFont::GetRect(const string &str, SDL_Rect &rect)
{
	rect = sge_TTF_TextSize(m_font, (char *)str.c_str() );
}


} // namespace
